from pandac.PandaModules import Vec2,Vec3,Vec3D,VBase4
from pandac.PandaModules import Spotlight,PerspectiveLens,Fog,OrthographicLens
from pandac.PandaModules import PointLight, AmbientLight, DirectionalLight, VBase4, Vec3,NodePath
import random

class Lights:
    #===========================================================================
    """initialize"""
    def __init__(self,ancestor,lightsOn=True,showLights=False):
        print "____________________________________________________"
        print "Class Lights"   
        self.ancestor=ancestor
        
        #Initialize bg colour
        colour = (0,0,0)
        base.setBackgroundColor(*colour)
        
        if lightsOn==False: return

        # Initialise lighting
        self.alight = AmbientLight('alight')
        self.alight.setColor(VBase4(0.25, 0.25, 0.25, 1))
        self.alnp = render.attachNewNode(self.alight)
        render.setLight(self.alnp) 
        
        self.dlight = DirectionalLight('dlight')
        self.dlight.setColor(VBase4(1.0, 1.0, 0.8, 1))
        self.dlnp = render.attachNewNode(self.dlight)
        self.dlnp.setHpr(45, -45, 32)
        render.setLight(self.dlnp)
            
        ## self.plight = PointLight('plight')
        ## self.plight.setColor(VBase4(0.8, 0.8, 0.5, 1))
        ## self.plnp = render.attachNewNode(self.plight)
        ## self.plnp.setPos(32, 32, 16)
        
        ## self.slight = Spotlight('slight')
        ## self.slight.setColor(VBase4(1, 1, 1, 1))
        ## lens = PerspectiveLens()
        ## self.slight.setLens(lens)
        ## self.slnp = render.attachNewNode(self.slight)
        ## self.slnp.setPos(-16, -16, 4)
        ## self.slnp.lookAt(64,64,0)
        
        #Initialize linear fog
        self.fog = Fog("Fog object") 
        self.fog.setMode(Fog.MLinear)
        self.fog.setLinearRange(14.0,40.0)
        self.fog.setColor(*colour)
        base.camLens.setFar(40.0)
        render.setFog(self.fog)
        
        
        
        
        